//    LightMP3
//    Copyright (C) 2007 Sakya
//    sakya_tg@yahoo.it
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#include <mad.h>
#include <pspkernel.h>
#include <pspsdk.h>
#include <pspaudiocodec.h>
#include <pspaudio.h>
#include <pspaudiolib.h>

#define OPENING_OK 0
#define ERROR_OPENING -1
#define ERROR_INVALID_SAMPLE_RATE -2
#define ERROR_MEMORY -3
#define ERROR_CREATE_THREAD -4

//shared global vars for ME
extern int HW_ModulesInit;
extern SceUID fd;
extern u16 data_align;
extern u32 sample_per_frame;
extern u16 channel_mode;
extern u32 samplerate;
extern long data_start;
extern long data_size;
extern u8 getEDRAM;
extern u32 channels;
extern SceUID data_memid;
extern volatile int OutputBuffer_flip;

extern float MP3ME_playingTime;

struct fileInfo{
	double fileSize;
	char layer[12];
	int kbit;
	long instantBitrate;
	long hz;
	char mode[52];
	char emphasis[20];
	long length;
	long frames;
	long framesDecoded;

    //Tag/comments:
	char album[260];
	char title[260];
	char artist[260];
	char genre[260];
    char year[8];
    char trackNumber[8];
};

void MP3ME_Init(int channel);
int MP3ME_Play();
void MP3ME_Pause();
int MP3ME_Stop();
void MP3ME_End();
int MP3ME_Load(char *filename);
int MP3ME_EndOfStream();
struct fileInfo MP3ME_GetInfo();
int MP3ME_GetPercentage();

